﻿using UnityEditor;
using UnityEngine;

public abstract class AbstractShapeInspector<T> : Editor where T : AbstractShape
{
    public override void OnInspectorGUI()
    {
        serializedObject.Update();

        DrawPropertiesExcluding(serializedObject);

        if (GUILayout.Button("Refresh"))
        {
            ((T) target).Refresh();
        }

        if (serializedObject.ApplyModifiedProperties())
        {
            ((T) target).Refresh();
            EditorUtility.SetDirty(target);
        }
    }
}