﻿using UnityEngine;

[ExecuteInEditMode]
public class GlowSimple : MonoBehaviour
{
    private AbstractShape myAbstractShape;
    protected AbstractShape parentShape;

    protected void Awake()
    {
        transform.localPosition = new Vector3(transform.localPosition.x, transform.localPosition.y, 1);
    }

    protected void OnEnable()
    {
        myAbstractShape = GetComponent<AbstractShape>();
        parentShape = transform.parent.GetComponent<AbstractShape>();

        parentShape.EventRefreshedColor += OnParentShapeRefreshedColor;
        parentShape.EventRefreshedColorAlpha += OnParentShapeRefreshedColorAlpha;
    }

    protected void OnDisable()
    {
        parentShape = transform.parent.GetComponent<AbstractShape>();

        parentShape.EventRefreshedColor -= OnParentShapeRefreshedColor;
        parentShape.EventRefreshedColorAlpha -= OnParentShapeRefreshedColorAlpha;
    }

    private void OnParentShapeRefreshedColor(Color? outlineColor, Color? fillColor, Color? outlineColorGlow)
    {
        myAbstractShape.RefreshColors(outlineColorGlow, null, null);
    }

    private void OnParentShapeRefreshedColorAlpha(float percent)
    {
        myAbstractShape.RefreshColors(percent);
    }
}
