﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

public class ShapeCircle : AbstractShape
{
    [SerializeField] private int pointResolution = 1;
    [SerializeField] private float controlPointHandleDistance = 0.55f;

    public override void Refresh()
    {
        base.Refresh();

        pointResolution = Mathf.Max(pointResolution, 1);

        int pointCount = (int) Mathf.Pow(2, 1 + pointResolution);

        var currentControlPointHandleDistance = controlPointHandleDistance / pointResolution * scale;

        RefreshPointCount(pointCount);

        float angle = 0;
        float angleDelta = Mathf.PI * 2 / pointCount;

        for (int i = 0; i < pointCount; i++)
        {
            var position = new Vector3(Mathf.Cos(angle), Mathf.Sin(angle)) * scale;

            var controlPointAngle = angle + 90 * Mathf.Deg2Rad;

            //var innerControlPoint = new Vector3(position.y, -position.x).normalized * pointData.controlPointDistance * scale * controlPointDistanceMultiplier;
            var innerControlPoint = new Vector3(Mathf.Cos(controlPointAngle), Mathf.Sin(controlPointAngle)) * currentControlPointHandleDistance;

            SetNaturalPoint(i, position, innerControlPoint);

            angle -= angleDelta;
        }

        RefreshMesh();
    }
}
